<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniscmmiscrcvintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_scm_misc_rcv_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniscmmiscrcvint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "transaction_number",
        "organization_id",
        "subinventory_code",
        "transfer_date",
        "type_misc",
        "source_code",
        "process_flag",
        "transaction_mode",
        "lock_flag",

        "attribute2",
        "attribute14",
        "inventory_item_id",
        "item_segment1",
        "transaction_quantity",
        "transaction_uom",
        "transaction_date",
        "transaction_source_type_id",
        "transaction_action_id",
        "flagsync",
        "voyage_call",
        "total_line"


    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Penerimaan/Penggunaan Makanan", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniscmmiscrcvintModel())->getQuery()
                ->whereNull("stgpelniscmmiscrcvint.flagsync")
                ->orWhere("stgpelniscmmiscrcvint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniscmmiscrcvintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Penerimaan/Penggunaan Makanan", Carbon::now()->toDateTimeString(), "", "success");
        }
    }


    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_scm_misc_rcv_int (TRANSACTION_NUMBER,ORGANIZATION_ID,SUBINVENTORY_CODE,TRANSFER_DATE,TYPE_MISC,SOURCE_CODE,PROCESS_FLAG,
TRANSACTION_MODE,LOCK_FLAG,ATTRIBUTE2,INVENTORY_ITEM_ID,ITEM_SEGMENT1,TRANSACTION_QUANTITY,TRANSACTION_UOM,TRANSACTION_DATE,TRANSACTION_SOURCE_TYPE_ID,TRANSACTION_ACTION_ID, VOYAGE_CALL, TOTAL_LINE, ATTRIBUTE14) 
VALUES (
'" . $data->transaction_number . "','" . $data->organization_id . "',
'" . $data->subinventory_code . "',TO_DATE('" . Carbon::parse($data->transfer_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),
'" . $data->type_misc . "','" . $data->source_code . "',
'" . $data->process_flag . "','" . $data->transaction_mode . "','" . $data->lock_flag . "',
'" . $data->attribute2 . "','" . $data->inventory_item_id . "',
'" . $data->item_segment1 . "','" . $data->transaction_quantity . "','" . $data->transaction_uom . "',
TO_DATE('" . Carbon::parse($data->transaction_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),'" . $data->transaction_source_type_id . "',
'" . $data->transaction_action_id . "', '" . $data->voyage_call . "', '" . $data->total_line . "', '" . $data->attribute14 . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("[ORA]Penerimaan/Penggunaan Makanan : ". $data->transaction_number." - ".$data->type_misc . " - " . $data->item_segment1, Carbon::now()->toDateTimeString(), "", "posted");
            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("[ORA]Penerimaan/Penggunaan Makanan : ". $data->transaction_number." - ".$data->type_misc . " - " . $data->item_segment1, Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}